import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement (name = "Contract")
public class Contract {
		private String contractId="";
		private String prod=""; 
		private String name="";
		private String longName="";
		private String dlvryStart = "";
		private String dlvryEnd = "";
		private String predefined = "";
		private String revisionNo = "";
		private String state = "";
		private String tradingPhase = "";
		private String duration = "";
		private String actPoint = "";
		private String expPoint = "";
		private String delUnits = "";
		private int deliveryAreaNb = 0;	
		private List<DeliveryArea> deliveryAreaList = new ArrayList<DeliveryArea>();
		private String chosenAreaToTrade = ""; // used for order generation, using a specific area
		
		public String getChosenAreaToTrade() {
			return chosenAreaToTrade;
		}
		public void setChosenAreaToTrade(String chosenAreaToTrade) {
			this.chosenAreaToTrade = chosenAreaToTrade;
		}



	public List<DeliveryArea> getDeliveryAreaList() {
			return deliveryAreaList;
		}
		public void setDeliveryAreaList(List<DeliveryArea> deliveryAreaList) {
			this.deliveryAreaList = deliveryAreaList;
		}

		public String getContractId() {
			return contractId;
		}
		public void setContractId(String contractId) {
			this.contractId = contractId;
		}
		public String getProd() {
			return prod;
		}
		public void setProd(String prod) {
			this.prod = prod;
		}
		public String getName() {
			return name;
		}
		public void setName(String name) {
			this.name = name;
		}
		public String getDlvryStart() {
			return dlvryStart;
		}
		public void setDlvryStart(String dlvryStart) {
			this.dlvryStart = dlvryStart;
		}
		public String getDlvryEnd() {
			return dlvryEnd;
		}
		public void setDlvryEnd(String dlvryEnd) {
			this.dlvryEnd = dlvryEnd;
		}
		public String getPredefined() {
			return predefined;
		}
		public void setPredefined(String predefined) {
			this.predefined = predefined;
		}
		public String getRevisionNo() {
			return revisionNo;
		}
		public void setRevisionNo(String revisionNo) {
			this.revisionNo = revisionNo;
		}
		public String getState() {
			return state;
		}
		public void setState(String state) {
			this.state = state;
		}
		public String getTradingPhase() {
			return tradingPhase;
		}
		public void setTradingPhase(String tradingPhase) {
			this.tradingPhase = tradingPhase;
		}
		public String getDuration() {
			return duration;
		}
		public void setDuration(String duration) {
			this.duration = duration;
		}
		public String getActPoint() {
			return actPoint;
		}
		public void setActPoint(String actPoint) {
			this.actPoint = actPoint;
		}
		public String getExpPoint() {
			return expPoint;
		}
		public void setExpPoint(String expPoint) {
			this.expPoint = expPoint;
		}
		public String getDelUnits() {
			return delUnits;
		}
		public void setDelUnits(String delUnits) {
			this.delUnits = delUnits;
		}
		public String getLongName() {
			return longName;
		}
		public void setLongName(String longName) {
			this.longName = longName;
		}
		public int getDeliveryAreaNb() {
			return deliveryAreaNb;
		}
		public void setDeliveryAreaNb(int deliveryAreaNb) {
			this.deliveryAreaNb = deliveryAreaNb;
		}

	// ***************************************************
	// *** toString
	// ***************************************************	
	@Override
	public String toString() {
		String s;
		s = "Contract Id=" + this.contractId + "product = "+ this.prod + " name=" + this.name + " longName=" + this.longName + " dlvryStart="+ this.dlvryStart + " dlvryEnd=" + this.dlvryEnd 
				+ " predefined=" + this.predefined + " revisionNo=" + this.revisionNo + " state="+ this.state + " tradingPhase="+ this.tradingPhase
				+ " nb of areas : "+ this.getDeliveryAreaNb() + " " + " chosen area to trade = " + chosenAreaToTrade
				+ this.getDeliveryAreaList().toString(); 
		return s; 
		
	}
	
	
}
