import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JOptionPane;

public class Globals {
public static String marketState ="";
public static int M7_OMT = 0;
public static int local_OMT = 0;
public static int remote_OMT = 0;
public static int EPEX_OG_M7_OMT = 0;
public static int EPEX_OG_local_OMT = 0;
public static int EPEX_OG_remote_OMT = 0;
public static int players_Count = 0;
public static int AMQPConnectionLossNb = 0;
public static String remoteProductSuffix = ""; 	// adapt to each environment

// requests state depending on the progress of the response processing :Waiting, Unzipping, Unzipped, Not compressed (if not compressed initially), Being Processed, Processed
public static boolean throttlingDataOngoingDrawing = false;
public static String REQ_STATE_WAITING = "0. Waiting for response...";
public static String REQ_STATE_RECEIVED = "1. Response Received";
public static String REQ_STATE_UNZIPPING = "2a. Response Unzipping...";
public static String REQ_STATE_UNZIPPED = "3. Response Unzipped";
public static String REQ_STATE_NOT_COMPRESSED = "2b. Response Not compressed";
public static String REQ_STATE_BEING_PROCESSED = "4. Response Being processed...";
public static String REQ_STATE_PROCESSED = "5. Response Processed";
public static String REQ_STATE_ERROR_RESP = "99. Error Response";

public static String connectedUserName = ""; // used to display the user name in all Windows title
public static boolean bBroadcastProcessingCanStart = false; // when all mandatory responses have been received (e.g. Contract Info report)

public static boolean coolDownPeriod = false;

public static boolean bOrderBookUpdate_Ongoing = false; 

public static GUIWindow guiWindowDebug;
public static ControlBoard controlBoardFrame;

private final static String FILE_GLOBALS_NAME = "Global indicators.csv";
private final static String NEW_LINE_SEPARATOR ="\n";
private final static String CSV_SEPARATOR =";";
private final static String FILE_GLOBALS_HEADER = "M7 OMT"+CSV_SEPARATOR + 
													"Local OMT"+CSV_SEPARATOR
													+ "Remote OMT" + CSV_SEPARATOR
													+ "" + CSV_SEPARATOR
													+ "EPEX OG M7 OMT"+CSV_SEPARATOR  
													+ "EPEX OG Local OMT"+CSV_SEPARATOR
													+ "EPEX OG Remote OMT"+ CSV_SEPARATOR
													+ "" + CSV_SEPARATOR
													+ "Nb of players"
													+ NEW_LINE_SEPARATOR;
//***************************************************
//*** Constructor
//***************************************************	
public Globals (ControlBoard controlBoardFrame) {
	Globals.controlBoardFrame = controlBoardFrame;
	if (Globals.guiWindowDebug == null) {
		guiWindowDebug = new GUIWindow("Debug", 800,600,1100,300);
		guiWindowDebug.setVisible(false);
		//guiWindowDebug.requestFocus();		
	}
	//Globals.guiWindowDebug.AddText("Constructor: ["+Thread.currentThread().getName()+ "] M7_OMT="+   Globals.M7_OMT + " local_OMT="+   Globals.local_OMT + " remote_OMT="+   Globals.remote_OMT);
}

//***************************************************
//*** Increment global OMT counts
//***************************************************
public static void Increment_OMT(int M7_OMT_increment, int local_OMT_increment, int remote_OMT_increment, 
								 int EPEX_OG_M7_OMT_increment, int EPEX_OG_local_OMT_increment, int EPEX_OG_remote_OMT_increment,
								 int players_Count_increment,
								String correlationId) {
	if (M7_OMT_increment == 1) Globals.M7_OMT ++;
	if (local_OMT_increment == 1) Globals.local_OMT ++;
	if (remote_OMT_increment == 1) Globals.remote_OMT ++;
	
	if (EPEX_OG_M7_OMT_increment == 1) Globals.EPEX_OG_M7_OMT ++;
	if (EPEX_OG_local_OMT_increment == 1) Globals.EPEX_OG_local_OMT ++;
	if (EPEX_OG_remote_OMT_increment == 1) Globals.EPEX_OG_remote_OMT ++;
	
	if (players_Count_increment == 1) Globals.players_Count ++;
	
	if (Globals.M7_OMT %1000 == 0) {
	Globals.guiWindowDebug.AddText("\t[Correlation ID = '"+correlationId+ "' Thread='"+ Thread.currentThread().getName()+ "'] M7_OMT="+   Globals.M7_OMT + " local_OMT="+   Globals.local_OMT + " remote_OMT="+   Globals.remote_OMT);		
	}

}

// ***************************************************
// *** WritePlayersListCSVFile
// ***************************************************	
public static void Write_Globals_CSVFile() {
	System.out.println("Writing Globals file: Globals.local_OMT=" + Globals.local_OMT);
	try {
         File f = new File(FILE_GLOBALS_NAME);
         if(!f.exists()) {
            f.createNewFile();
         }
         
		FileWriter fileWriter = new FileWriter(FILE_GLOBALS_NAME);
		
		if(f.length() == 0) fileWriter.append(FILE_GLOBALS_HEADER);
			
		String row = 	Globals.M7_OMT + CSV_SEPARATOR
							+ Globals.local_OMT + CSV_SEPARATOR
							+ Globals.remote_OMT + CSV_SEPARATOR
							+ "" + CSV_SEPARATOR
							+ Globals.EPEX_OG_M7_OMT + CSV_SEPARATOR
							+ Globals.EPEX_OG_local_OMT + CSV_SEPARATOR
							+ Globals.EPEX_OG_remote_OMT + CSV_SEPARATOR
							+ "" + CSV_SEPARATOR
							+ Globals.players_Count
							+ NEW_LINE_SEPARATOR;
		fileWriter.append(row);
		
		fileWriter.flush();
		fileWriter.close();				
	
	} catch (IOException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
		String msg = "the " + FILE_GLOBALS_NAME + " file cannot be accessed : please check it is well closed."; 
		JOptionPane.showMessageDialog(Globals.controlBoardFrame, msg);
	}		
}

//***************************************************
//*** Initialize all variables (to be used in case of connection loss) 
//*** if historical orders are being retrieved
//***************************************************	
 public static void Init() {
	 M7_OMT = 0;
	 local_OMT = 0;
	 remote_OMT = 0;
	 EPEX_OG_M7_OMT = 0;
	 EPEX_OG_local_OMT = 0;
	 EPEX_OG_remote_OMT = 0;
	 players_Count = 0;
 }
 // ****************************************
 // ** get price with decimals in a String
 // ****************************************
 public static String getPriceWithDecimals(String inputPrice) {
	 String priceWithDecimals ="";
	 if (!inputPrice.equals("") && !inputPrice.contains(".")) {
		 float price = Integer.parseInt(inputPrice) / 100;
		 priceWithDecimals = String.valueOf(price);		 
	 } // nothing to do
	 else priceWithDecimals = inputPrice; 
 
	 return priceWithDecimals;
 }
 
 // ****************************************
 // ** get qty with decimals in a String
 // ****************************************
 public static String getQtyWithDecimals(String inputQty) {
	 String qtyWithDecimals = "";
	 if (!inputQty.equals("") && !inputQty.contains(".")) {
		 float qty= Integer.parseInt(inputQty) / 1000;
		 qtyWithDecimals = String.valueOf(qty);		 
	 } // nothing to do
	 else qtyWithDecimals = inputQty;

	 return qtyWithDecimals;
 }
}
