
public class RoutingKey {
	
	private String msgTypePrefix = "com.deutscheboerse.m7.trading.api.v6.";

	private String previousBroadcastMsgType = "";
	private String routingKeyName= "";
	private int currentSequenceNo= 0;
	private int previousSequenceNo= 0;
	private int missingSequenceNo = 0;
	private int nbOfBroadcasts = 0;
	private boolean bReceived = false;
	private String missingSinceDateTime = "";
	private String receivedFinallyAtDateTime = "";
	private boolean gapDetected = false;
	private String timeDiffSec = "";
	
	public boolean isbReceived() {
		return bReceived;
	}
	public void setbReceived(boolean bReceived) {
		this.bReceived = bReceived;
	}
	public String getMissingSinceDateTime() {
		return missingSinceDateTime;
	}
	public void setMissingSinceDateTime(String missingSinceDateTime) {
		this.missingSinceDateTime = missingSinceDateTime;
	}
	public String getReceivedFinallyAtDateTime() {
		return receivedFinallyAtDateTime;
	}
	public void setReceivedFinallyAtDateTime(String receivedFinallyAtDateTime) {
		this.receivedFinallyAtDateTime = receivedFinallyAtDateTime;
	}
	public boolean isGapDetected() {
		return gapDetected;
	}

	
	// for debug info / analyze gaps
	private String currentBroadcastMsgType = "";
	public String getCurrentBroadcastMsgType() {
		return currentBroadcastMsgType;
	}
	public void setCurrentBroadcastMsgType(String currentBroadcastMsgType) {
		//this.currentBroadcastMsgType = currentBroadcastMsgType.substring(msgTypePrefix.length());
		this.currentBroadcastMsgType = currentBroadcastMsgType;
	}
	public String getPreviousBroadcastMsgType() {
		return previousBroadcastMsgType;
	}
	public void setPreviousBroadcastMsgType(String previousBroadcastMsgType) {
		//this.previousBroadcastMsgType = previousBroadcastMsgType.substring(msgTypePrefix.length());
		this.previousBroadcastMsgType = previousBroadcastMsgType;
	}
	public String getRoutingKeyName() {
		return routingKeyName;
	}
	public void setRoutingKeyName(String routingKeyName) {
		this.routingKeyName = routingKeyName;
	}
	public int getCurrentSequenceNo() {
		return currentSequenceNo;
	}
	public void setCurrentSequenceNo(int currentSequenceNo) {
		this.currentSequenceNo = currentSequenceNo;
	}
	public int getPreviousSequenceNo() {
		return previousSequenceNo;
	}
	public void setPreviousSequenceNo(int previousSequenceNo) {
		this.previousSequenceNo = previousSequenceNo;
	}
	public int getMissingSequenceNo() {
		return missingSequenceNo;
	}
	public void setMissingSequenceNo(int missingSequenceNo) {
		this.missingSequenceNo = missingSequenceNo;
	}
	public boolean GetGapDetected() {
		return gapDetected;
	}
	public void setGapDetected(boolean gapDetected) {
		this.gapDetected = gapDetected;
	}
	public int getNbOfBroadcasts() {
		return nbOfBroadcasts;
	}
	public void setNbOfBroadcasts(int nbOfBroadcasts) {
		this.nbOfBroadcasts = nbOfBroadcasts;
	}

	public String getTimeDiffSec() {
		return timeDiffSec;
	}
	public void setTimeDiffSec(String timeDiffSec) {
		this.timeDiffSec = timeDiffSec;
	}
	
	public String Display() {
		String s;
		String prefixGapDetected = "";
		if (this.gapDetected == true) {
			prefixGapDetected = "** GAP DETECTED **";
		}
		s = 		prefixGapDetected
					+ " nbOfBroadcasts = " + String.format("%1$-" + 10 + "d", this.nbOfBroadcasts)
					+ String.format("%1$-" + 80 + "s", this.routingKeyName) 
					+ " previousSequenceNo = " + String.format("%1$-" + 10 + "d", this.previousSequenceNo) 
					+ " currentSequenceNo = " + String.format("%1$-" + 10 + "d", this.currentSequenceNo)
					+ " missingSequenceNo = " + String.format("%1$-" + 10 + "d", this.missingSequenceNo)
					+ " previous type= " + String.format("%1$-" + 40 + "s", this.previousBroadcastMsgType)
					+ " current type= " + String.format("%1$-" + 40 + "s", this.currentBroadcastMsgType); 
	return s; 
		
	}

}
