import javax.swing.JOptionPane;

public class ThreadPeriodicThrottlingStatusReq implements Runnable {

	private SampleCode sampleCode;
	private String throttlingStatusReqIntervalMillisec;
	private int defaultTimeMs = 3000;
	private AMQPConnection amqpConnection;
	
	// constructor
	public ThreadPeriodicThrottlingStatusReq(SampleCode sampleCode, AMQPConnection amqpConnection) {
		this.sampleCode = sampleCode;
		this.amqpConnection = amqpConnection;
		this.throttlingStatusReqIntervalMillisec = sampleCode.throttlingStatusReqIntervalMillisec;
		//JOptionPane.showMessageDialog(sampleCode.controlBoardFrame, "Periodic Throttling Status request thread start");
	}
	
	// *************************************
	// Send periodic requests
	// *************************************
	@Override
	public void run() {
		// TODO Auto-generated method stub
		//JOptionPane.showMessageDialog(sampleCode.controlBoardFrame, "Thread Throttling : amqpConnection.ConnectionIsOpen() = "+ amqpConnection.ConnectionIsOpen() + " sampleCode.bThrottlingEnabled=" + sampleCode.bThrottlingEnabled);
		
		int i = 0;
		
		while (amqpConnection.ConnectionIsOpen() && sampleCode.bThrottlingEnabled) {
			try {
				i ++;
				sampleCode.sendThrottlingStatusReq();

			}
			catch (Exception e) {
				e.printStackTrace();
				String msg = "ThreadPeriodicThrottlingStatusReq sending Throttling Status Request issue" + e.toString();
				Globals.guiWindowDebug.AddText(msg);
				sampleCode.appLog.logger.warning("msg");				
			}
			
			try {
				if (throttlingStatusReqIntervalMillisec!= null)	Thread.sleep(Integer.parseInt(throttlingStatusReqIntervalMillisec));
				else Thread.sleep(3000);
			} 
			catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				Globals.guiWindowDebug.AddText("ThreadPeriodicThrottlingStatusReq issue" + e.toString());
				try {
					Thread.sleep(defaultTimeMs);
				} catch (InterruptedException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
					Globals.guiWindowDebug.AddText("ThreadPeriodicThrottlingStatusReq issue" + e1.toString());
					sampleCode.appLog.logger.warning("ThreadPeriodicThrottlingStatusReq issue" + e1.toString());
				}
			}
		}	
	}
}
