import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;

public class ThrottlingDataJPanel extends JPanel implements ActionListener {
	
	private static final long serialVersionUID = 1L;
	public boolean bShortRule = true;
	String ruleType = "";
	static int nbChartDrawings = 0;
	int OFFSET = 70;
	int POINT_SIZE = 5;
	
	// x,y represent the value to draw on the chart
	// x_Chart and y_Chart represent the pixel value to draw x or y on the chart (depends on x0, on the applied scale/zoom etc.)
	// => there are methods this.getXChart, this.getYChart provided to do that conversion job
	int x_Chart, y_Chart,x_ChartApprox, y_ChartApprox, previousX_Chart, previousY_Chart, previousX_ChartApprox, previousY_ChartApprox ;
	int previousOMT_Y;
	int OMT_flag;
	int errResp_flag;
	int ackResp_flag;
	int cooldownStart_flag;
	String previousruleType_Status, ruleType_Status;
	int SIZE_FACTOR = 2;
	int X_INCREASE_FACTOR = 3;
	int Y_INCREASE_FACTOR = 40;
    int scaleX = 1;
    int scaleY = 1;
    int x0_Chart = OFFSET;
    int y0_Chart = OFFSET;
    int ruleType_L1 = 0;
    int ruleType_L2 = 0;
    boolean bManual_Y_Height = false;
    ThrottlingDataList throttlingDataListLocal = null;
    WindowOGStartStop windowOGControlLocal = null;
    //JCheckBox enrichedChartCheckBox = new JCheckBox("Enriched Chart");
    JButton buttonPlus_X, buttonMinus_X, buttonPlus_Y, buttonMinus_Y, buttonReset;
    boolean force_reDraw_buttons_Plus_Minus = true;
    String FRAME_TITLE = "Throttling Data Chart";
    ThrottlingDataChartFrame frame;
    ControlBoard controlBoardFrame;
    Log appLog;
    
    // ***************************************************
    // Constructor 
    // ***************************************************
    public ThrottlingDataJPanel(String ruleType, ControlBoard controlBoardFrame, ThrottlingDataChartFrame frame,ThrottlingDataList throttlingDataList, WindowOGStartStop windowOrderGenerationControl, Log appLog) {
        this.ruleType = ruleType;
    	if ("SHORT".contentEquals(ruleType)) bShortRule = true; // depends on the rule the chart is used for
        else bShortRule = false;
    	this.throttlingDataListLocal = throttlingDataList;
        this.windowOGControlLocal = windowOrderGenerationControl;
        this.frame = frame;
        this.controlBoardFrame = controlBoardFrame;
        this.appLog = appLog;

        buttonPlus_X = new JButton("X +"); 
        buttonMinus_X = new JButton("X -");
        buttonPlus_Y = new JButton("Y +");
        buttonMinus_Y = new JButton("Y -");
        buttonReset = new JButton("Reset zoom");

        this.add(buttonPlus_X); buttonPlus_X.addActionListener(this);
 	   	this.add(buttonMinus_X); buttonMinus_X.addActionListener(this);
	   	this.add(buttonPlus_Y);  buttonPlus_Y.addActionListener(this);
	   	this.add(buttonMinus_Y); buttonMinus_Y.addActionListener(this);
	   	this.add(buttonReset); 	buttonReset.addActionListener(this);
    }
    
	// ***************************************************
	// *** initialize the chart
	// ***************************************************    
	public void initChart(Graphics2D g2d, int x0_Chart, int y0_Chart) {
        int x1,y1,x2,y2 = 0;
 	   	
		// background
	   	g2d.setPaint(Color.black);
        // Draw X axis
        x1 = OFFSET;
        x2 = this.getWidth()-OFFSET-10;
        y1 = this.getHeight()-OFFSET;
        y2 = y1;
        g2d.drawLine(x1, y1, x2, y2);
        
	   	// Draw Y axis
        x1 = OFFSET;
        x2 = x1;
        y1 = this.getHeight()-OFFSET;
        y2 = OFFSET;
        g2d.drawLine(x1, y1, x2, y2);
        
        // display scale
	   	g2d.setPaint(Color.black);
	    g2d.setFont(new Font("Tahoma", Font.BOLD, 14));
	   	g2d.drawString("rolling OMT count",  1*(int)(OFFSET/3), 2*y2/3);
        g2d.drawString("0", 2*OFFSET/3, this.getYChart(0) );
        //g2d.drawString("OMT count", 2*OFFSET/3, this.getYChart(14) );

       // g2d.drawString("rolling OMT count", 2*(int)(OFFSET/3), this.getYChart( 2*(int)(this.getHeight()/100 )));
    
		x_Chart = x0_Chart;
		y_Chart = y0_Chart;
		
	}
	   // ***********************************************************
	   //  drawLoad
	   // 
	   // ***********************************************************
	    void drawLoad(Graphics g) {
	      	    
	    	//Globals.guiWindowDebug.AddText("Globals.throttlingDataOngoingDrawing = " + Globals.throttlingDataOngoingDrawing);
	        //if (Globals.throttlingDataOngoingDrawing == false) {
	        //	Globals.throttlingDataOngoingDrawing = true;
	        	nbChartDrawings++;
	    	
		        Graphics2D g2d = (Graphics2D) g;
		        
		        initChart(g2d,x0_Chart,y0_Chart);
		        
		    	g2d.setPaint(Color.black);
		    	boolean bScaleChange = false;
		    	
		    	//int nbSec = 0;
		                
				// bigger black Font
		    	g2d.setPaint(Color.black);
				Font stringFont = new Font( "SansSerif", Font.BOLD, 13);
		    	g2d.setFont(stringFont);
		    	g2d.setStroke(new BasicStroke(2));
		    	
		    	// **********************
		    	// size the chart : determine the max recorded Y between OMT count, L1 and L2 for the relevant rule
		    	// **********************
		    	int max_X_Throttling = 0;
		    	int max_Y_Throttling = 0;
    			String L2 ="";
    			
		    	// if no Y zoom button has been pushed, adjust the height automatically : start by determining the X_max and Y_max
		    	if (this.throttlingDataListLocal != null) { 
		    		int pointNb = 0;

	    			
		    		for (ThrottlingStatus next : throttlingDataListLocal.throttlingDataList) {
		    			pointNb++;
	
		    			// get x and y to size the chart and apply a display factor/Ratio if required, for the chart to be visible in the panel
		    			// if OMT is low, make sure we can see L2
		    			String OMTCount;
		    			if (bShortRule) {
		    				OMTCount = next.Short_OmtCount;
		    				L2 = next.Short_L2; 
		    			}
		    			else {
		    				OMTCount = next.Long_OmtCount;
		    				L2 = next.Long_L2;
		    			}
		    			
		    			if (OMTCount != null && !OMTCount.contentEquals("")) {
			    			if (Integer.parseInt(OMTCount) > max_Y_Throttling) {
				    				// take L2 as a max as long as below L2
		    					// 
				    				if (L2 != null && !L2.contentEquals("")) max_Y_Throttling = Math.max ( Integer.parseInt(OMTCount), Integer.parseInt(L2)); // determine the max Y point
			    				}
		    			}
		    		}
		    		// if max_Y_Throttling is still 0 (not OMT counted at all) then initialize it to L2
		    		if (max_Y_Throttling == 0 && (L2 != null && !L2.contentEquals(""))) max_Y_Throttling = Integer.parseInt(L2);
		    				    		
		            // ********************************************************
		            // reshape the graph if it's getting too close to borders
		    		// ********************************************************
		            // resize X
		            int resizeTrials = 1;
	
		            // adjust scale X until the new point stays within the graph boundaries
		            //int xLimit = (this.getWidth()-x0_Chart)*X_INCREASE_FACTOR/scaleX;
		            int xLimit = this.getWidth()-x0_Chart;
	     
		           // System.out.println("max_X_Throttling =" + max_X_Throttling + " max_Y_Throttling = " + max_Y_Throttling);
		            //System.out.println(" xLimit= "+ xLimit + " this.getWidth()-x0_Chart="+ (this.getWidth()-x0_Chart) + " scaleX = " + scaleX + " X_INCREASE_FACTOR=" + X_INCREASE_FACTOR+  ")");
		            //System.out.println("resize check start");
		            
		           // System.out.println("this.getXChart(max_X_Throttling)=" + this.getXChart(max_X_Throttling) + " xLimit="+ xLimit + " this.getXChart(xLimit)=" + this.getXChart(xLimit));
	        		while (this.getXChart(max_X_Throttling) > xLimit ) {
	    				scaleX = scaleX*SIZE_FACTOR; // SIZE_FACTOR conditions the speed at which X progresses (slow or fast to the right)
	        			bScaleChange = true;
	        	        if (bScaleChange == true) {
	    	        		//displayChart (g2d, true, Color.lightGray, appLogLocal);
	    	        		initChart(g2d,x0_Chart,y0_Chart);
	    	        		//System.out.println("scale X change = "+ scaleX);
	    	        }
	        			//System.out.println("this.getXChart(max_X_Throttling) = " + this.getXChart(max_X_Throttling) + " : scaleX changed = " + scaleX);
	        			resizeTrials++;
	        			if (resizeTrials>10000) break;
	        		}
	        		// resize Y until the highest point on the chart is visible with a margin (OFFSET)
		            resizeTrials = 1;
	        		while ( this.getYChart(max_Y_Throttling) < OFFSET && !bManual_Y_Height) {
	    				scaleY = scaleY*SIZE_FACTOR;        			
	        			bScaleChange = true;
	        	        if (bScaleChange == true) {
	    	        		//displayChart (g2d, true, Color.lightGray, appLogLocal);
	    	        		initChart(g2d,x0_Chart,y0_Chart);
	    	        		//System.out.println("scale Y change = "+ scaleY);
	    	        }
	        			//System.out.println("this.getYChart(max_Y_Throttling) = " + this.getYChart(max_Y_Throttling) + " scaleY changed = " + scaleY);
	        			resizeTrials++;
	        			if (resizeTrials>10000) break;
	        		}
	    	        /*if (bScaleChange == true) {
		        		initChart(g2d,x0_Chart,y0_Chart);
	    	        }*/
	        		
	        		//=> scale X and Y are determined to see the full chart
	        		
	           		// *****************************
	                // draw lines between all points
	           		// *****************************
	        		//System.out.println("before test windowOGControlLocal.checkboxChart_Refresh_Requested = " +  windowOGControlLocal.checkboxChart_Refresh_Requested);
	        		boolean force_redraw_full_chart = false;
	        		
	        		// if + or - buttons pressed, force redraw
	                if (bScaleChange == true || windowOGControlLocal.checkboxChart_Refresh_Requested == true || force_reDraw_buttons_Plus_Minus) { // need to resize the chart : draw the full chart
	               	  	
	                	windowOGControlLocal.checkboxChart_Refresh_Requested = false; // so that no unnecessary refresh is requested
	               	 	windowOGControlLocal.testLabel.setText("refreshing chart");
	               	 
	               	 	force_redraw_full_chart = true;
	                }
	                else { // only draw the last point

	                	force_redraw_full_chart = true;//false;
	                	// test always force redraw (blinks... but no missed point because of concurrent access!)
	                	//force_redraw_full_chart = true;
	                }
	            	displayChart (g2d, force_redraw_full_chart);
	            	
	            	force_reDraw_buttons_Plus_Minus = false;
		    	}
	        }
	    	//Globals.throttlingDataOngoingDrawing = false;
	   // }
	    	
 	// ***************************************************
 	// *** getXChart
 	// ***************************************************
    public int getXChart(int X) {
    	int XChart = x0_Chart + (int)(X_INCREASE_FACTOR*(X/scaleX)) ;
    	return XChart;
    }
 	// ***************************************************
 	// *** getYChart
 	// ***************************************************
    public int getYChart(int Y) {
    	
    	int YChart = (this.getHeight() - y0_Chart) - ((Y * Y_INCREASE_FACTOR)/scaleY) ;
    	//System.out.println("this.getHeight() = "+ this.getHeight() + " y0_Chart = "+ y0_Chart + " Y = "+ Y + " Y_INCREASE_FACTOR= " + Y_INCREASE_FACTOR  + " result =" + YChart);
    	return YChart;
    }
    
    // ***********************************************************
    // draw the chart in the indicated color, 
    // with an option to only display the last 2 points (avoid the blinking effect to moments where the chart needs to be resized)
    // ***********************************************************
    public void displayChart (Graphics2D g2d, boolean bDrawFullChart) {

    	Color statusColor; 
        int pointNb = 0;
        boolean bDrawLine = true;
        int ruleType_OW = 0;
                
		frame.setTitle(ruleType + " " + FRAME_TITLE + " (User: " + Globals.connectedUserName + " / " +  throttlingDataListLocal.throttlingDataList.size() + " points)");
        
        if (bDrawFullChart == true) {
        	initChart(g2d, x0_Chart, y0_Chart);
        }
        
        // for each "point" of throttling data
		for (ThrottlingStatus next : throttlingDataListLocal.throttlingDataList) {
				boolean bValid_OMT_Point = true;
				pointNb++;
				        	
	        	// determine current points value
	        	x_Chart = this.getXChart(pointNb);
				if (bShortRule) {
		        	if (next.Short_OmtCount != null & !"".contentEquals(next.Short_OmtCount)) {
		        		y_Chart = this.getYChart(Integer.parseInt(next.Short_OmtCount));	
		        		bValid_OMT_Point = true;
		           	}
		        	else {// skip this point, incomplete
		        		y_Chart = 0;
		        		bValid_OMT_Point = false;
		        	}
				} 
				else { // LONG rule
		        	if (next.Long_OmtCount != null & !"".contentEquals(next.Long_OmtCount)) {
		        		y_Chart = this.getYChart(Integer.parseInt(next.Long_OmtCount));	
		        		bValid_OMT_Point = true;
		           	}
		        	else {// skip this point, incomplete
		        		y_Chart = 0;
		        		bValid_OMT_Point = false;
		        	}					
				}		        	
	        	
	        	// determine "flag" bars for the chart bottom
	        	if (next.M7_AckResp != null && !next.M7_AckResp.contentEquals("")) ackResp_flag = Integer.parseInt(next.M7_AckResp);
	        	else ackResp_flag = 0; 	
	        	if (next.M7_OMT_OrdrExeRprt != null && !next.M7_OMT_OrdrExeRprt.contentEquals("")) OMT_flag = Integer.parseInt(next.M7_OMT_OrdrExeRprt);
	        	else OMT_flag = 0;
	        	if (next.M7_errResp != null && !next.M7_errResp.contentEquals("")) errResp_flag = Integer.parseInt(next.M7_errResp);
	        	else errResp_flag = 0;
	        	if (next.cooldownTheoreticalStart != null && !next.cooldownTheoreticalStart.contentEquals("")) cooldownStart_flag = Integer.parseInt(next.cooldownTheoreticalStart);
	        	else cooldownStart_flag = 0;
				
	        	if (bShortRule) ruleType_Status = next.Short_status;
	        	else ruleType_Status = next.Long_status;
	        		        		
				// OMT count internal approximation
	        	x_ChartApprox = x_Chart; 
	        	if (next.Short_OmtCountApproximation != null & !next.Short_OmtCountApproximation.contentEquals("")) {
	        		y_ChartApprox = this.getYChart(Integer.parseInt(next.Short_OmtCountApproximation));
	        	}
	        	else y_ChartApprox = 0;
	        	
	  			if (pointNb == 1) {
    				previousX_Chart= x_Chart; 
    				previousY_Chart = y_Chart;
    				previousX_ChartApprox = x_ChartApprox;
    				previousY_ChartApprox = y_ChartApprox;
    				previousruleType_Status = ruleType_Status;
    			}
	  			
	        	// if not the last point do not draw the line when the full chart is not requested
	        	if (!bValid_OMT_Point || (bDrawFullChart==false && pointNb < throttlingDataListLocal.throttlingDataList.size())) bDrawLine = false;
	        	else bDrawLine = true;
	        		        	
	        	// force to draw each line when the chart is resized or if a new indicator is added/removed: bDrawLine set to true
	        	if (bDrawLine == true) {
		  			// redraw short L1 and L2
	    			if (pointNb == 1) {
	    				// get L1 and L2 for the relevant rule
	    				if (bShortRule) {
	    					if (next.Short_L1 != null && !next.Short_L1.contentEquals("")) ruleType_L1 = Integer.parseInt(next.Short_L1);
	    					else ruleType_L1 = 0;
	    					if (next.Short_L2 != null && !next.Short_L2.contentEquals("")) ruleType_L2 = Integer.parseInt(next.Short_L2);
	    					else ruleType_L2 = 0;
	    				}
	    				else  
	    				{
	    					if (next.Long_L1 != null && !next.Long_L1.contentEquals("")) ruleType_L1 = Integer.parseInt(next.Long_L1);
	    					else ruleType_L1 = 0;
	    					if (next.Long_L2 != null && !next.Long_L2.contentEquals("")) ruleType_L2 = Integer.parseInt(next.Long_L2);
	    					else ruleType_L2 = 0;
    					}
				   		
				    	// draw L1
		    			g2d.setStroke(new BasicStroke(2));
					   	g2d.setPaint(Color.orange);
					   	g2d.drawLine(x0_Chart, getYChart(ruleType_L1), this.getWidth()- OFFSET, getYChart(ruleType_L1) );
					   	if (bShortRule) g2d.drawString(next.Short_L1 , getXChart(0)/5, getYChart(ruleType_L1) );
					   	else  g2d.drawString(next.Long_L1 , getXChart(0)+ x0_Chart/5, getYChart(ruleType_L1)-10);
	    		
				    	// draw L2
		    			g2d.setStroke(new BasicStroke(2));
		    			g2d.setPaint(Color.red);
					   	g2d.drawLine(x0_Chart, getYChart(ruleType_L2), this.getWidth()- OFFSET, getYChart(ruleType_L2) );
					   	
					   	if (bShortRule) g2d.drawString(next.Short_L2 , getXChart(0)/5, getYChart(ruleType_L2) );
					   	else g2d.drawString(next.Long_L2 , getXChart(0)+ x0_Chart/5, getYChart(ruleType_L2)-10);
    			}
    			

	    			statusColor = Color.black ;
				   	// determine the lien color depending on the status of the previous point
		        	if (previousruleType_Status.contentEquals("NO_RESTRICTION")) {
		        		statusColor = Color.blue;	
		        	}
		        	else if (previousruleType_Status.contentEquals("WARNING")) {
		        		statusColor = Color.orange;
		        	}
		        	else if (previousruleType_Status.contentEquals("RESTRICTED")) {
		        		statusColor = Color.red;
		        	}
		        	else {
		        		appLog.logger.warning("Unkown value for previousruleType_Status");
		        	}
		        	
	    			// internal approximation (smaller and a bit in advance)
		        	if (windowOGControlLocal.checkboxChartChecked == true && bShortRule) {
		        		g2d.setPaint(Color.magenta);
			        	g2d.setStroke(new BasicStroke(2));
		        		g2d.drawLine(previousX_ChartApprox, previousY_ChartApprox, x_ChartApprox, y_ChartApprox);
		        	}
		        			    			
	    			// draw color bars for AckResp, OrderExe (OMT) and ErrResp
	    			int y1_bar = this.getYChart(0)+OFFSET/3;
	    			int y2_bar = this.getYChart(0)+OFFSET;
	    			
	    			// ackResp events = 0 or 1
	    			// only works for the internal order generator (no AckResp receives for orders submitted by another app)
	    			
	    			if (ackResp_flag == 1) {
			        	g2d.setStroke(new BasicStroke(2));
		    			g2d.setPaint(Color.green); 
			    		g2d.drawLine(x_Chart, y1_bar+OFFSET/3, x_Chart, y2_bar);// make Ack Resp a bit smaller	    				
		    		}
	    			
	    			// OMT events = 0 or 1 : do not trace when no event (0-0)
		        	//System.out.println(" previousOMT_flag=" + previousOMT_flag + " OMT_flag ="+ OMT_flag);
	    			
	    			if ( OMT_flag == 1) {
			        	g2d.setStroke(new BasicStroke(2));
		    			g2d.setPaint(statusColor);
		    			//System.out.println("previousX_Chart="+ previousX_Chart+ " previousOMT_Y="+ previousOMT_Y + " x="+x+ " OMT_Y="+OMT_Y);
		    			g2d.drawLine(x_Chart, y1_bar, x_Chart, y2_bar );
	    			}
	    			
	    			// ErrResp events = 0 or 1
	    			if ( errResp_flag == 1) {
			        	g2d.setStroke(new BasicStroke(2));
		    			g2d.setPaint(Color.red); 
		    			g2d.drawLine(x_Chart, y1_bar+OFFSET/3, x_Chart, y2_bar);   // make Err Resp a bit smaller	  				
		    		}
	    			
    			if (bShortRule) {
	    			// cooldown start events = 0 or 1
	    			if ( cooldownStart_flag == 1) {
			        	g2d.setStroke(new BasicStroke(2));
		    			g2d.setPaint(Color.DARK_GRAY); 
		    			int y3_bar;
		    			y3_bar = this.getYChart(ruleType_L1); // y_Chart
		    			g2d.drawLine(x_Chart, this.getYChart(0), x_Chart, y3_bar);  
		    			//drawVerticalDottedLine(g2d,x_Chart, this.getYChart(0), x_Chart, y3_bar, Color.DARK_GRAY);
		    		}
	    			// cooldown exit events = 0 or 1
	    			if ( cooldownStart_flag == 2) {
			        	g2d.setStroke(new BasicStroke(2));
		    			g2d.setPaint(Color.GREEN); 
		    			int y3_bar;
		    			y3_bar = this.getYChart(ruleType_L1); // y_Chart
		    			g2d.drawLine(x_Chart, this.getYChart(0), x_Chart, y3_bar);		    			
		    			//drawVerticalDottedLine(g2d,x_Chart, this.getYChart(0), x_Chart, y3_bar, Color.GREEN);
		    		}
    			}	
	    			// add the M7 short/long current OMT count 
						g2d.setStroke(new BasicStroke(2));
					   	g2d.setPaint(statusColor);
			        	g2d.drawLine(previousX_Chart, previousY_Chart, x_Chart, y_Chart);
			        	
			        	if (pointNb == this.throttlingDataListLocal.throttlingDataList.size()) {
			        		if (bShortRule) g2d.drawString(next.Short_OmtCount,  x_Chart + 5, y_Chart - 5);
			        		else g2d.drawString(next.Long_OmtCount,  x_Chart + 5, y_Chart - 5);
			        	}
			        
			        	//g2d.setColor(statusColor);
						//g2d.drawString(next.Short_OmtCount, x_Chart+10, y_Chart-10);

	             }
	        	
	        	g2d.setStroke(new BasicStroke(2));
           	
	        	// current point becomes previous point (to draw the next line)
	        	if (bValid_OMT_Point) { // keep the previous point if the current point is not "valid" (no OMT count)
					previousX_Chart = x_Chart; 
					previousY_Chart = y_Chart;
					previousX_ChartApprox = x_ChartApprox;
					previousY_ChartApprox = y_ChartApprox;

					previousruleType_Status = ruleType_Status;	        		
	        	}

	        }
    	// draw the sliding observation window
		g2d.setStroke(new BasicStroke(3));
		g2d.setPaint(Color.magenta);		   	
		int X1_ruleType_OWLine, X2_ruleType_OWLine;
		if ( throttlingDataListLocal.throttlingDataList.size() > 0 ) {
			String ruleType_OWString = throttlingDataListLocal.throttlingDataList.get(throttlingDataListLocal.throttlingDataList.size()-1).Short_observationWindow;
        	if (ruleType_OWString != null && !ruleType_OWString.contentEquals("")) {
        		ruleType_OW = Integer.parseInt(ruleType_OWString);	
        	}
        	else ruleType_OW = 30;
				
		}
		else ruleType_OW = 10;
		
		int shortSlidingOWlength = this.getXChart(ruleType_OW); 
		
		if (throttlingDataListLocal.throttlingDataList.size() < ruleType_OW) X1_ruleType_OWLine = this.getXChart(1);
		else X1_ruleType_OWLine =  this.getXChart(throttlingDataListLocal.throttlingDataList.size())-shortSlidingOWlength;
		
		X2_ruleType_OWLine =  this.getXChart(throttlingDataListLocal.throttlingDataList.size());
		
		int Y_OWLine = this.getYChart(0)+OFFSET/7; // just below the X axis
		
		g2d.drawLine(X1_ruleType_OWLine, Y_OWLine ,X2_ruleType_OWLine, Y_OWLine);
		
        }

  	// ***************************************************
  	// *** draw vertical dotted line
  	// ***************************************************	
	public void drawVerticalDottedLine(Graphics2D g2d, int x1, int y1, int x2, int y2, Color colorLine) {
		int dottedSubLineHeight = 5; // how many points on the chart represent a value of 10 OMT
		g2d.setPaint(colorLine);
		
		for (int y = y1; y > y2; y = y - 2*dottedSubLineHeight) {
			
			g2d.drawLine(x1, y, x2, y - dottedSubLineHeight);
		}
	}

    
  	// ***************************************************
  	// *** Manage button clicks
  	// ***************************************************	
	@Override
	public void actionPerformed(ActionEvent e) {
		// TODO Auto-generated method stub

		if (e.getSource()==buttonPlus_X) {
			X_INCREASE_FACTOR = X_INCREASE_FACTOR*2;
			System.out.println(" + pressed: X_INCREASE_FACTOR  = "+X_INCREASE_FACTOR );
			
			force_reDraw_buttons_Plus_Minus = true;
			this.repaint();
			}
		
		if (e.getSource()==buttonMinus_X) {
			X_INCREASE_FACTOR = X_INCREASE_FACTOR/2;
			System.out.println(" + pressed: X_INCREASE_FACTOR  = "+X_INCREASE_FACTOR );
			force_reDraw_buttons_Plus_Minus = true;
			this.repaint();
			}
		
		if (e.getSource()==buttonPlus_Y) {
	    	bManual_Y_Height = true;
			Y_INCREASE_FACTOR = Y_INCREASE_FACTOR*2;
			System.out.println(" + pressed: Y_INCREASE_FACTOR  = "+Y_INCREASE_FACTOR );
			
			force_reDraw_buttons_Plus_Minus = true;
			this.repaint();
			}
		
		if (e.getSource()==buttonMinus_Y) {
	    	bManual_Y_Height = true;
			Y_INCREASE_FACTOR = Y_INCREASE_FACTOR/2;
			System.out.println(" + pressed: Y_INCREASE_FACTOR  = "+Y_INCREASE_FACTOR );
			force_reDraw_buttons_Plus_Minus = true;
			this.repaint();
			}
		if (e.getSource()==buttonReset) {
			SIZE_FACTOR = 2;
			X_INCREASE_FACTOR = 3;
			Y_INCREASE_FACTOR = 40;
			scaleX = 1;
			scaleY = 1;
			force_reDraw_buttons_Plus_Minus = true;
			//System.out.println("RESET button clicked : (X_zoom = "+ X_INCREASE_FACTOR +" Y_X_zoom = "+Y_INCREASE_FACTOR + " ScaleX = " + scaleX +" ScaleY = " + scaleY + ")");
			this.repaint();
			}		
		frame.setTitle(ruleType + " " + FRAME_TITLE + " (User: " + Globals.connectedUserName + " / " +  throttlingDataListLocal.throttlingDataList.size() + " points)");
	}
	
 	// ***************************************************
 	// *** paintComponent
 	// ***************************************************	
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
        drawLoad(g);
     }

}
