import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.JTextField;

public class ThrottlingStatus {
	
	// strategy
	String strategy = "";
	// message data
	String sourceMessage = "";
	String correlationId = "";
	String clientReceptionTime = "";

	// OMT real data taken from Order Exe Report 
	String M7_OMT_OrdrExeRprt = "0";
	String M7_lastUpdateTm = "";
	
	// Ack Resp (order accepted)
	String M7_AckResp = "0";
	
	// error Response count (OMT attempt failures, whatever is the reason)
	String M7_errResp = "0";
	
	// cooldown start
	String cooldownTheoreticalStart = "0";
	
	// throttling status data

	String mbrId = "";
	String timestamp = "";
	String globalStatus = "";

	String Short_status ="";
	int Short_status_nb =0;
	String Short_OmtCount ="";
	String Short_OmtCountApproximation = "";
	String Short_releaseTimestamp = "";
	String Short_observationWindow ="";
	String Short_tolerance = "";
	String Short_cooldown = "";
	String Short_L1 = "";
	String Short_L2 = "";

	String Long_status ="";
	String Long_OmtCount ="";
	String Long_releaseTimestamp = "";
	String Long_observationWindow ="";
	String Long_tolerance = "";
	String Long_cooldown = "";
	String Long_L1 = "";
	String Long_L2 = "";
	
	// M7_Msg_Report_Announced_Release
	String M7_Msg_Report_Announced_Short_ReleaseTime = "";
	
	SimpleDateFormat sdfTime = new SimpleDateFormat("HH:mm:ss") ;
	int statusRespNb = 0;
	
	private ControlBoard controlBoardFrame;
	
	private final static String FILE_THROTTLING_RESP = "Throttling data.csv";
	private final static String NEW_LINE_SEPARATOR ="\n";
	private final static String CSV_SEPARATOR =";";
	private final static String FILE_THROTTLING_RESP_HEADER =
														"Strategy" + CSV_SEPARATOR + 
														"Source Msg"+CSV_SEPARATOR +
														"Correlation Id"+CSV_SEPARATOR +
														"M7 order lastupdate tm" + CSV_SEPARATOR +
														"Throttling Response Timestamp" + CSV_SEPARATOR +
														"Client Resp. Reception Time"+CSV_SEPARATOR +
														"M7 AckResp (Accepted)" + CSV_SEPARATOR +
														"M7 OMT (OrdrExeRprt)" + CSV_SEPARATOR +
														"M7 ErrResp (Rejected)" + CSV_SEPARATOR +
														"SHORT L1" + CSV_SEPARATOR + 
														"SHORT L2" + CSV_SEPARATOR + 
														"SHORT current OMT" +CSV_SEPARATOR +
														"SHORT internal current OMT approximation" +CSV_SEPARATOR +
														"SHORT Status nb (NO_RES = -8, WARNING = -7, RESTRICTED = -6)" + CSV_SEPARATOR +
														"SHORT status" +CSV_SEPARATOR +
														"SHORT Release Time" +CSV_SEPARATOR +
														"SHORT OW" +CSV_SEPARATOR +
														"SHORT Tolerance" +CSV_SEPARATOR +
														"SHORT Cooldown" +CSV_SEPARATOR +
														"LONG L1" + CSV_SEPARATOR + 
														"LONG L2" + CSV_SEPARATOR + 
														"Long current OMT" +CSV_SEPARATOR +
														"LONG status" +CSV_SEPARATOR +
														"LONG Release Time" +CSV_SEPARATOR +
														"LONG OW" +CSV_SEPARATOR + 
														"LONG Tolerance" +CSV_SEPARATOR + 
														"LONG Cooldown" 
														+ NEW_LINE_SEPARATOR;
	
	// constructor 
	public ThrottlingStatus (ControlBoard controlBoardFrame) {
		this.controlBoardFrame = controlBoardFrame;
	}
	// ***************************************************
	// *** WriteThrottlingStatusResponsesCSVFile
	// ***************************************************	
	public void deleteThrottlingStatusResponsesCSVFile() {
		// create other functional required files
		File f = new File(FILE_THROTTLING_RESP);
		if (f.exists()) {
			f.delete();
		  }
	}
	// ***************************************************
	// *** WriteThrottlingStatusResponsesCSVFile_Header
	// ***************************************************	
	public void WriteThrottlingStatusResponsesCSVFile_Header() {
		try {
			FileWriter fileWriter = new FileWriter(FILE_THROTTLING_RESP);
			fileWriter.append(FILE_THROTTLING_RESP_HEADER);
	
			fileWriter.flush();
			fileWriter.close();
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			JOptionPane.showMessageDialog(controlBoardFrame, "catching error: "+ e.toString());
		}		
	}
	// ***************************************************
	// *** WriteThrottlingStatusResponsesCSVFile
	// ***************************************************	
	public void WriteThrottlingStatusResponsesCSVFile() {
		try {
			FileWriter fileWriter = new FileWriter(FILE_THROTTLING_RESP, true);
//			if (this.statusRespNb == 1) fileWriter.append(FILE_THROTTLING_RESP_HEADER);
			
			String row = 	this.strategy + CSV_SEPARATOR
							+ this.sourceMessage + CSV_SEPARATOR
							+ this.correlationId + CSV_SEPARATOR
							+ this.M7_lastUpdateTm + CSV_SEPARATOR
							+ this.timestamp + CSV_SEPARATOR
							+ this.clientReceptionTime + CSV_SEPARATOR
							+ this.M7_AckResp + CSV_SEPARATOR
							+ this.M7_OMT_OrdrExeRprt + CSV_SEPARATOR
							+ this.M7_errResp + CSV_SEPARATOR
							+ this.Short_L1 + CSV_SEPARATOR
							+ this.Short_L2 + CSV_SEPARATOR
							+ this.Short_OmtCount + CSV_SEPARATOR
							+ this.Short_OmtCountApproximation + CSV_SEPARATOR
							+ determineStatusNb(this.Short_status) + CSV_SEPARATOR
							+ this.Short_status + CSV_SEPARATOR
							+ this.Short_releaseTimestamp + CSV_SEPARATOR
							+ this.Short_observationWindow + CSV_SEPARATOR
							+ this.Short_tolerance + CSV_SEPARATOR
							+ this.Short_cooldown + CSV_SEPARATOR
							+ this.Long_L1 + CSV_SEPARATOR
							+ this.Long_L2 + CSV_SEPARATOR
							+ this.Long_OmtCount + CSV_SEPARATOR
							+ this.Long_status + CSV_SEPARATOR
							+ this.Long_releaseTimestamp + CSV_SEPARATOR
							+ this.Long_observationWindow + CSV_SEPARATOR
							+ this.Long_tolerance + CSV_SEPARATOR
							+ this.Long_cooldown 
							+ NEW_LINE_SEPARATOR;
				fileWriter.append(row);
		
			fileWriter.flush();
			fileWriter.close();
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			String msg = "the " + FILE_THROTTLING_RESP + " file cannot be accessed : please check it is well closed."; 
			JOptionPane.showMessageDialog(Globals.controlBoardFrame, msg);
		}		
	}
	// ************************************************************************
	// *** Update the GUI table displaying Order data 
	// ************************************************************************
	public void copy(ThrottlingStatus throttlingStatusToBeCopied) throws Exception {
		this.mbrId 			= throttlingStatusToBeCopied.mbrId;
		this.globalStatus 	= throttlingStatusToBeCopied.globalStatus;

		this.Short_cooldown = throttlingStatusToBeCopied.Short_cooldown;
		this.Short_L1 		= throttlingStatusToBeCopied.Short_L1;
		this.Short_L2 		= throttlingStatusToBeCopied.Short_L2;
		this.Short_observationWindow = throttlingStatusToBeCopied.Short_observationWindow;
		this.Short_OmtCount = throttlingStatusToBeCopied.Short_OmtCount;
		this.Short_OmtCountApproximation = throttlingStatusToBeCopied.Short_OmtCountApproximation;
		this.Short_releaseTimestamp = throttlingStatusToBeCopied.Short_releaseTimestamp;
		this.Short_status 		= throttlingStatusToBeCopied.Short_status;
		this.Short_status_nb 	= throttlingStatusToBeCopied.Short_status_nb;
		this.Short_tolerance= throttlingStatusToBeCopied.Short_tolerance;
		
		this.Long_cooldown	= throttlingStatusToBeCopied.Long_cooldown;
		this.Long_L1 		= throttlingStatusToBeCopied.Long_L1;
		this.Long_L2 		= throttlingStatusToBeCopied.Long_L2;
		this.Long_observationWindow = throttlingStatusToBeCopied.Long_observationWindow;
		this.Long_OmtCount 	= throttlingStatusToBeCopied.Long_OmtCount;
		this.Long_releaseTimestamp = throttlingStatusToBeCopied.Long_releaseTimestamp;
		this.Long_status 	= throttlingStatusToBeCopied.Long_status;
		this.Long_tolerance = throttlingStatusToBeCopied.Long_tolerance;
		
	
		// do not copy message data nor M7 data

	}
	// ************************************************************************
	// *** Update the GUI table displaying Order data 
	// ************************************************************************
	public void updateGUITable(JTable ThrottlingTable, JTextField commentText) {
		int columnNb = 0;
		int rowNb = 0;
		this.statusRespNb ++;
		commentText.setText(mbrId + " Last response received at " + this.clientReceptionTime+  " Response timestamp: "+  timestamp);
		
		// 1st row : generic info
		columnNb = 0;
		ThrottlingTable.setValueAt("GLOBAL:",rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt("N/A",rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(globalStatus,rowNb,columnNb); columnNb++ ;

		rowNb ++;
		
		// skip a row
		columnNb = 3;
		ThrottlingTable.setValueAt("Short OMT Approx. = " + Short_OmtCountApproximation,rowNb,columnNb); columnNb++ ;
		rowNb ++;
		
		// 2nd row : SHORT rule info
		// {"RULE","L1","L2","Status","OMT count","Release Time","Observation","Tolerance","Cooldown"};
		columnNb = 0;
		ThrottlingTable.setValueAt("SHORT RULE:",rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Short_releaseTimestamp,rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Short_status,rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Short_OmtCount,rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Short_L1,rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Short_L2,rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Short_observationWindow,rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Short_tolerance,rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Short_cooldown,rowNb,columnNb); columnNb++ ;
		rowNb++;
		
		// 3rd row : LONG rule info
		columnNb = 0;
		ThrottlingTable.setValueAt("LONG RULE:",rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Long_releaseTimestamp,rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Long_status,rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Long_OmtCount,rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Long_L1,rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Long_L2,rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Long_observationWindow,rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Long_tolerance,rowNb,columnNb); columnNb++ ;
		ThrottlingTable.setValueAt(Long_cooldown,rowNb,columnNb); columnNb++ ;
		
		WriteThrottlingStatusResponsesCSVFile();
	}
	
	// ************************************************************************
	// *** Convert status into a nb to be able to feature it on a chart
	// ************************************************************************
	public int determineStatusNb(String status) {
		int statusNb = 0;
		if (status.contentEquals("NO_RESTRICTION")) statusNb = -8;
		else if (status.contentEquals("WARNING")) 	statusNb = -7;
		else if (status.contentEquals("RESTRICTED")) statusNb= -6;
		return statusNb;
	}
	
	// ************************************************************************
	// *** update the current throttling status with new data and add it to the list
	// ************************************************************************
	public void addNewThrottlingData(boolean bThrottlingEnabled, String sourceMsg, String msgReceptionTm, String msgLastUpdTm,
				String msgCorrelationId, String selectedStrategy, String M7_AckResp, String M7_OMT_OrdrExeRprt, String M7_ErrResp,
				OrdersList ordersList, ThrottlingDataChartFrame throttlingDataChart, ThrottlingDataList throttlingDataList ) {
		if (bThrottlingEnabled) {
			ThrottlingStatus newThrottlingStatus = new ThrottlingStatus(controlBoardFrame);
			try {
				newThrottlingStatus.copy(this);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				String msg = "Catching error in  previousThrottlingStatus.copy : " + e.toString();
				JOptionPane.showMessageDialog(Globals.controlBoardFrame, msg);			
			}
			
			newThrottlingStatus.strategy = selectedStrategy;
			newThrottlingStatus.correlationId = msgCorrelationId;
			newThrottlingStatus.sourceMessage = sourceMsg;
			newThrottlingStatus.clientReceptionTime = msgReceptionTm;
			newThrottlingStatus.M7_lastUpdateTm = msgLastUpdTm;

			newThrottlingStatus.M7_AckResp = M7_AckResp;
			newThrottlingStatus.M7_OMT_OrdrExeRprt = M7_OMT_OrdrExeRprt;
			newThrottlingStatus.M7_errResp = M7_ErrResp;
			
			if (newThrottlingStatus.Short_observationWindow != null && !newThrottlingStatus.Short_observationWindow.contentEquals("")) {
				newThrottlingStatus.Short_OmtCountApproximation = Integer.toString(ordersList.countUserOMTduringPeriod(Integer.valueOf(newThrottlingStatus.Short_observationWindow)));
			}
			
			throttlingDataList.Add(newThrottlingStatus, controlBoardFrame);
			
			throttlingDataChart.repaint();
			newThrottlingStatus.WriteThrottlingStatusResponsesCSVFile(); 
		}
	}
	
	
}
