import java.util.Date;
import java.util.ListIterator;
import java.util.concurrent.CopyOnWriteArrayList;

import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;

public class TradesList {
	private CopyOnWriteArrayList<Trade> tradesList = new CopyOnWriteArrayList<>();
	int nbTrades = 0;
	
	
	// ***************************************************
	// *** Add a trade to the list 
	// ***************************************************
	public void AddTrade(Trade trade) {		
		this.tradesList.add(trade);
		this.nbTrades ++;
	}
	
	
	// ************************************************************************
	// *** Update a trade in the list (if recalled or cancelled, or any intermediary state (please refer to DFS180 and M7 API FAQ 
	// ************************************************************************
	public void UpdateTradesList(Trade newTrade) {

		boolean bTrade_Found = false;
		
		ListIterator<Trade> list_Iter = tradesList.listIterator(); 
		while (list_Iter.hasNext()) {
			Trade tradeItr = list_Iter.next();
			
			if ( tradeItr.tradeId.contentEquals(newTrade.tradeId)) {
				// BG already listed : just update values
				bTrade_Found = true;
	
				// update the state

				tradeItr.state = newTrade.state;
					}
		}
		// if Obk could not be found in the list : add it
		if (bTrade_Found == false) {
		
			this.AddTrade(newTrade);
		}
	}
	
	// ************************************************************************
	// *** Update the trade GUI table 
	// ************************************************************************
	public void updateGUITable(GUI_Panel trades_GUI_Panel) {
		int row = 0;
		int columnNb = 0;
		
		boolean alreadySortedOnce = false;
		JTable table = trades_GUI_Panel.table;
		JTextField commentText = trades_GUI_Panel.commentText;
		DefaultTableModel dataModel = trades_GUI_Panel.dataModel;
		
	if (!trades_GUI_Panel.bPaused) {
		commentText.setText("Nb of trades = " + this.nbTrades);

	ListIterator<Trade> list_Iter = tradesList.listIterator(); 
	while (list_Iter.hasNext()) {
		Trade trade_Itr = list_Iter.next();
			
		  // extend the table when reaching the end
		  if  (row == table.getRowCount()) dataModel.addRow(new Object[] { row });
		  
		  columnNb = 0;
		   // {"#","Trade Id","remote Trade Id", "RevisionNo", "Contract Id", "Contract Name", "Product", "State", "ExecutionTime", "XBID trade", "Quantity", "Price", "buy Area", "Sell Area", "Pre-Arranged (OTC)"};
		  table.setValueAt(String.format("%04d", row+1),row,columnNb); columnNb++ ;
		  table.setValueAt(trade_Itr.tradeId,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.remoteTradeId,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.revisionNo,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.side,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.contractId,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.contractName,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.contractPhase,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.product,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.state,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.executionTime,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.isXBID,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.quantity,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.price,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.deliveryAreaName,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.accountId,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.txt,row,columnNb); columnNb++;
		  table.setValueAt(trade_Itr.selfTrade,row,columnNb); columnNb++;

		  table.setValueAt(trade_Itr.preArranged,row,columnNb); columnNb++;
		  
		  row++;
 	  }
	 
	 // only sort once so that the user can change the sorting 
	 if (alreadySortedOnce == false) {
			table.getRowSorter().toggleSortOrder(1);
			table.getRowSorter().toggleSortOrder(1);
		 alreadySortedOnce = true;
	 }
	}
	}	
}
