import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

public class WindowOGStartStop extends JFrame implements ActionListener {
	public boolean orderGeneration_ON = false;
    JPanel container_panel_OG = new JPanel(new FlowLayout());
	JButton buttonOrderGeneration = new JButton("RESUME/PAUSE");
	JButton buttonOrderClick = new JButton("CLICK = ORDER");
	String LABEL_RUNNING = "RUNNING            ";
	String LABEL_PAUSED = "PAUSED...           ";
	String LABEL_AUTO_SENDING_OMT = "Strategy: OMT sending...";
	String LABEL_AUTO_WAITING = "Strategy: WAITING for algo strategy auto-restart conditions";
	JLabel label = new JLabel(LABEL_PAUSED);
	JLabel labelStrategyAuto = new JLabel(LABEL_AUTO_WAITING);

	JComboBox<String> strategyCB = null;
	String strategy = ""; 
	JCheckBox enrichedChartCheckBox = new JCheckBox("client OMT estimation");
	boolean checkboxChartChecked = false;
	boolean checkboxChart_Refresh_Requested = false; // used to force the redraw of the whole throttling data chart when requesting to add/remove the M7 current OMT count

	JLabel testLabel = new JLabel("");
	SampleCode sampleCode;
	
	public WindowOGStartStop(SampleCode sampleCode) {
		this.sampleCode = sampleCode;
				
	    // window order generation
		this.setTitle("Periodic Order Generation");
		this.setBounds(1380,890-50,500,150+50);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		container_panel_OG.setBackground(Color.LIGHT_GRAY);
		this.setContentPane(container_panel_OG);
		
		// button to start/stop order generation
		container_panel_OG.add(buttonOrderClick);
		buttonOrderClick.addActionListener(this);
		container_panel_OG.add(buttonOrderGeneration);
		buttonOrderGeneration.addActionListener(this);
		
		this.setContentPane(container_panel_OG);
	
		// label corresponding to the button action
		container_panel_OG.add(label);
		this.setOrderGenerationOFF();
		
		// enriched chart checkbox
		container_panel_OG.add(enrichedChartCheckBox);	
		enrichedChartCheckBox.setSelected(false);
		enrichedChartCheckBox.addItemListener(new ItemListener() {
            @Override
            public void itemStateChanged(ItemEvent e) {
            	if (e.getStateChange() == ItemEvent.SELECTED) {
            		//System.out.println("checked");
            		checkboxChartChecked = true;
                	checkboxChart_Refresh_Requested = true;
            	}
            	else {
            		//System.out.println("Unchecked");
            		checkboxChartChecked = false;
                	checkboxChart_Refresh_Requested = true;
            	}
            }
        });
		// strategy choice combo box
		
		  String[] strategyList = {"#0. Periodic orders / Stops after nbOfOrders in config file (use RESUME/PAUSE)", "#1. SHORT: Stay under the radar: 0 < OMT < L1",
		  "#2. SHORT: Hit L1 and back off until OMT = 0", 
		  "#3a. SHORT: Optimize (L1 < OMT < L2), never exceed TP", "#3b. SHORT: Optimize (L1 < OMT < L2) until RESTRICTED",
		  "#4. SHORT: RESTRICTED - hit L2 and back off until release",   "#5. SHORT: RESTRICTED - Hit L2 and continue a bit before backing off",
		  "#6. RANDOM"}; 
		  strategyCB = new JComboBox<String>(strategyList); 
		  strategyCB.setSelectedIndex(0); // default selected strategy #
		  strategyCB.addActionListener(this); 
		  container_panel_OG.add(strategyCB);
		  strategy = strategyCB.getSelectedItem().toString();
		  //System.out.println("strategy =" + strategy);

		// add strategy comment
		  container_panel_OG.add(labelStrategyAuto);
		  this.setStrategyStatusTo_WaitingForAutoRestart();
		// make the panel visible
		this.setVisible(true);		
	}
	
	public void setStrategy (int i) {
		strategyCB.setSelectedIndex(i);
	}
	
	public void setOrderGenerationON() {
		label.setForeground(Color.black);
		label.setText(LABEL_RUNNING);
		orderGeneration_ON = true;
	}
	public void setOrderGenerationOFF() {
		label.setForeground(Color.red);
		label.setText(LABEL_PAUSED);
		orderGeneration_ON = false;
	}
	
	public void setStrategyStatusTo_WaitingForAutoRestart() {
		// waiting for algo restart conditions
		labelStrategyAuto.setForeground(Color.red);
		labelStrategyAuto.setText(LABEL_AUTO_WAITING);
	}
	public void setStrategyStatusTo_SendingOMT() {
		labelStrategyAuto.setForeground(Color.blue);
		labelStrategyAuto.setText(LABEL_AUTO_SENDING_OMT);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==buttonOrderGeneration) {
			if (label.getText().contentEquals(LABEL_RUNNING)) {
				setOrderGenerationOFF();
			}
			else if (label.getText().contentEquals(LABEL_PAUSED))  {
				setOrderGenerationON();
			}
		}
		else if (e.getSource()==buttonOrderClick) {
			sampleCode.SendCorrectOrderRandomContract();
		}
		
		else if (e.getSource()==strategyCB) {
			strategy = strategyCB.getSelectedItem().toString();
		}
	}
	
	/*
	 * public void itemStateChanged(ItemEvent e) { // if the state of checkbox1 is
	 * changed if (e.getSource() == enrichedChartCheckBox) { checkboxChart_Refresh_Requested =
	 * true; testLabel.setText("true");
	 * 
	 * if (e.getStateChange() == 1) { System.out.println("checked"); } else {
	 * System.out.println("Unchecked"); } } }
	 */
}